package net.mcreator.geafm.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.geafm.world.inventory.UpgradeSystemMenu;
import net.mcreator.geafm.procedures.ReturnGodXPAmountProcedure;
import net.mcreator.geafm.procedures.ReturnGodBloodAmountProcedure;
import net.mcreator.geafm.network.UpgradeSystemButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class UpgradeSystemScreen extends AbstractContainerScreen<UpgradeSystemMenu> {
	private final static HashMap<String, Object> guistate = UpgradeSystemMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	ImageButton imagebutton_ascensiontabletitem;
	ImageButton imagebutton_stargemchestplateitem;
	ImageButton imagebutton_potiontreeopen;
	ImageButton imagebutton_misctreeopen;

	public UpgradeSystemScreen(UpgradeSystemMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 425;
		this.imageHeight = 240;
	}

	@Override
	public boolean isPauseScreen() {
		return true;
	}

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal.png"), this.leftPos + 185, this.topPos + 80, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal.png"), this.leftPos + 194, this.topPos + 71, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal.png"), this.leftPos + 176, this.topPos + 89, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal.png"), this.leftPos + 167, this.topPos + 98, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal.png"), this.leftPos + 158, this.topPos + 107, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal2.png"), this.leftPos + 212, this.topPos + 71, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal2.png"), this.leftPos + 221, this.topPos + 80, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal2.png"), this.leftPos + 230, this.topPos + 89, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal2.png"), this.leftPos + 239, this.topPos + 98, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linediagonal2.png"), this.leftPos + 248, this.topPos + 107, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 248, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 239, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 230, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 221, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 212, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 203, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 194, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 185, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 176, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 167, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/linehorizantal.png"), this.leftPos + 158, this.topPos + 116, 0, 0, 15, 15, 15, 15);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.geafm.upgrade_system.label_upgrade_tree"), 181, 14, -103, false);
		guiGraphics.drawString(this.font,

				ReturnGodBloodAmountProcedure.execute(entity), 14, 215, -103, false);
		guiGraphics.drawString(this.font,

				ReturnGodXPAmountProcedure.execute(entity), 14, 206, -6684775, false);
	}

	@Override
	public void init() {
		super.init();
		imagebutton_ascensiontabletitem = new ImageButton(this.leftPos + 203, this.topPos + 62, 16, 16,
				new WidgetSprites(new ResourceLocation("geafm:textures/screens/ascensiontabletitem.png"), new ResourceLocation("geafm:textures/screens/ascensiontabletitem.png")), e -> {
					if (true) {
						PacketDistributor.SERVER.noArg().send(new UpgradeSystemButtonMessage(0, x, y, z));
						UpgradeSystemButtonMessage.handleButtonAction(entity, 0, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_ascensiontabletitem", imagebutton_ascensiontabletitem);
		this.addRenderableWidget(imagebutton_ascensiontabletitem);
		imagebutton_stargemchestplateitem = new ImageButton(this.leftPos + 149, this.topPos + 116, 16, 16,
				new WidgetSprites(new ResourceLocation("geafm:textures/screens/stargemchestplateitem.png"), new ResourceLocation("geafm:textures/screens/stargemchestplateitem.png")), e -> {
					if (true) {
						PacketDistributor.SERVER.noArg().send(new UpgradeSystemButtonMessage(1, x, y, z));
						UpgradeSystemButtonMessage.handleButtonAction(entity, 1, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_stargemchestplateitem", imagebutton_stargemchestplateitem);
		this.addRenderableWidget(imagebutton_stargemchestplateitem);
		imagebutton_potiontreeopen = new ImageButton(this.leftPos + 255, this.topPos + 115, 16, 16,
				new WidgetSprites(new ResourceLocation("geafm:textures/screens/potiontreeopen.png"), new ResourceLocation("geafm:textures/screens/potiontreeopen.png")), e -> {
					if (true) {
						PacketDistributor.SERVER.noArg().send(new UpgradeSystemButtonMessage(2, x, y, z));
						UpgradeSystemButtonMessage.handleButtonAction(entity, 2, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_potiontreeopen", imagebutton_potiontreeopen);
		this.addRenderableWidget(imagebutton_potiontreeopen);
		imagebutton_misctreeopen = new ImageButton(this.leftPos + 203, this.topPos + 116, 16, 16, new WidgetSprites(new ResourceLocation("geafm:textures/screens/misctreeopen.png"), new ResourceLocation("geafm:textures/screens/misctreeopen.png")),
				e -> {
					if (true) {
						PacketDistributor.SERVER.noArg().send(new UpgradeSystemButtonMessage(3, x, y, z));
						UpgradeSystemButtonMessage.handleButtonAction(entity, 3, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_misctreeopen", imagebutton_misctreeopen);
		this.addRenderableWidget(imagebutton_misctreeopen);
	}
}
