
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.geafm.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;

import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.network.chat.Component;
import net.minecraft.core.registries.Registries;

import net.mcreator.geafm.GeafmMod;

public class GeafmModTabs {
	public static final DeferredRegister<CreativeModeTab> REGISTRY = DeferredRegister.create(Registries.CREATIVE_MODE_TAB, GeafmMod.MODID);
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> QOL = REGISTRY.register("qol",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.geafm.qol")).icon(() -> new ItemStack(GeafmModItems.MATERIAL_COMPRESSOR_RECIPE_BOOK.get())).displayItems((parameters, tabData) -> {
				tabData.accept(GeafmModItems.MATERIAL_COMPRESSOR_RECIPE_BOOK.get());
				tabData.accept(GeafmModItems.STAR_CRAFTING_TABLE_RECIPE_BOOK.get());
			})

					.build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> ENERGY = REGISTRY.register("energy",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.geafm.energy")).icon(() -> new ItemStack(GeafmModBlocks.SOLAR_PANEL.get())).displayItems((parameters, tabData) -> {
				tabData.accept(GeafmModBlocks.MAGNETITE_ORE.get().asItem());
				tabData.accept(GeafmModBlocks.DEEPSLATE_MAGNETITE_ORE.get().asItem());
				tabData.accept(GeafmModItems.RAW_MAGNETITE.get());
				tabData.accept(GeafmModItems.MAGNETITE_INGOT.get());
				tabData.accept(GeafmModBlocks.BATTERY_1.get().asItem());
				tabData.accept(GeafmModBlocks.BATTERY_2.get().asItem());
				tabData.accept(GeafmModBlocks.BATTERY_3.get().asItem());
				tabData.accept(GeafmModBlocks.BATTERY_4.get().asItem());
				tabData.accept(GeafmModBlocks.BATTERY_5.get().asItem());
				tabData.accept(GeafmModBlocks.BATTERY_6.get().asItem());
				tabData.accept(GeafmModBlocks.BATTERY_7.get().asItem());
				tabData.accept(GeafmModBlocks.LOW_CAPACITY_CABLE_N.get().asItem());
				tabData.accept(GeafmModItems.ENERGY_CARRIER.get());
				tabData.accept(GeafmModItems.ENERGY_TREE.get());
				tabData.accept(GeafmModItems.ENERGY_FOREST.get());
				tabData.accept(GeafmModBlocks.SOLAR_PANEL.get().asItem());
				tabData.accept(GeafmModBlocks.STAR_POWERED_SOLAR_PANEL.get().asItem());
				tabData.accept(GeafmModBlocks.GODLY_SOLAR_PANEL.get().asItem());
				tabData.accept(GeafmModBlocks.MATERIAL_COMPRESSER.get().asItem());
				tabData.accept(GeafmModBlocks.ENERGY_TO_REDSTON_CONVERTER.get().asItem());
				tabData.accept(GeafmModItems.ENERGY_RADAR.get());
				tabData.accept(GeafmModBlocks.ORE_DUPLICATOR_BASE.get().asItem());
				tabData.accept(GeafmModBlocks.ORE_DUPLICATOR_BATTERY.get().asItem());
				tabData.accept(GeafmModBlocks.ENERGY_COOLER.get().asItem());
				tabData.accept(GeafmModBlocks.ENERGY_HEATING.get().asItem());
				tabData.accept(GeafmModBlocks.ORE_DUPLICATOR_CHISELER.get().asItem());
				tabData.accept(GeafmModBlocks.QUARRY.get().asItem());
				tabData.accept(GeafmModItems.MATERIAL_COMPRESSER_FORCE_UPGRADE.get());
			})

					.build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> EPIC_AND_FUN = REGISTRY.register("epic_and_fun",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.geafm.epic_and_fun")).icon(() -> new ItemStack(GeafmModItems.END_CRYSTAL.get())).displayItems((parameters, tabData) -> {
				tabData.accept(GeafmModBlocks.END_QUARTZ.get().asItem());
				tabData.accept(GeafmModItems.END_CRYSTAL.get());
				tabData.accept(GeafmModItems.STARDUST.get());
				tabData.accept(GeafmModItems.STAR_COAL.get());
				tabData.accept(GeafmModItems.STAR_METAL.get());
				tabData.accept(GeafmModItems.STAR_GEM.get());
				tabData.accept(GeafmModBlocks.STAR_BLOCK.get().asItem());
				tabData.accept(GeafmModItems.STAR_ALLOY.get());
				tabData.accept(GeafmModItems.STAR_METAL_ARMOR_HELMET.get());
				tabData.accept(GeafmModItems.STAR_METAL_ARMOR_CHESTPLATE.get());
				tabData.accept(GeafmModItems.STAR_METAL_ARMOR_LEGGINGS.get());
				tabData.accept(GeafmModItems.STAR_METAL_ARMOR_BOOTS.get());
				tabData.accept(GeafmModItems.STAR_GEM_TOOL_AXE.get());
				tabData.accept(GeafmModItems.STAR_GEM_TOOL_PICKAXE.get());
				tabData.accept(GeafmModItems.STAR_GEM_TOOL_SWORD.get());
				tabData.accept(GeafmModItems.STAR_GEM_TOOL_SHOVEL.get());
				tabData.accept(GeafmModItems.STAR_GEM_TOOL_HOE.get());
				tabData.accept(GeafmModItems.VOLATILE_STAR_SWORD.get());
				tabData.accept(GeafmModItems.STAR_SWORD.get());
				tabData.accept(GeafmModBlocks.STAR_CRAFTING_TABLE.get().asItem());
				tabData.accept(GeafmModBlocks.SHADED_DEEPSLATE.get().asItem());
				tabData.accept(GeafmModItems.SHADE_ESSENCE.get());
				tabData.accept(GeafmModItems.SHADE_BAR.get());
				tabData.accept(GeafmModItems.NIGHTMARE_FUEL.get());
				tabData.accept(GeafmModItems.NIGHTMARE_BAR.get());
				tabData.accept(GeafmModItems.HEAVENLY_FRAGMENT.get());
				tabData.accept(GeafmModItems.VOID_ESSENCE.get());
				tabData.accept(GeafmModItems.VOID_BAR.get());
				tabData.accept(GeafmModItems.ABYSSAL_ENERGY.get());
				tabData.accept(GeafmModItems.ABYSS_BAR.get());
				tabData.accept(GeafmModItems.BLACK_MATTER.get());
				tabData.accept(GeafmModItems.ANTIMATTER_BAR.get());
				tabData.accept(GeafmModItems.GOD_FRAGMENT.get());
				tabData.accept(GeafmModItems.GOD_BAR.get());
				tabData.accept(GeafmModItems.TRUE_EYE.get());
				tabData.accept(GeafmModItems.ASCENSION_FRAGMENT.get());
				tabData.accept(GeafmModItems.ASCENSION_TABLET.get());
				tabData.accept(GeafmModItems.ASCENSION_BAG.get());
				tabData.accept(GeafmModItems.ASCENSION_BAG_TIER_2.get());
				tabData.accept(GeafmModBlocks.COMPACTED_IRON.get().asItem());
				tabData.accept(GeafmModBlocks.COMPACTED_GOLD.get().asItem());
				tabData.accept(GeafmModBlocks.COMPACTED_DIAMOND.get().asItem());
				tabData.accept(GeafmModBlocks.COMPACTED_NETHERITE.get().asItem());
				tabData.accept(GeafmModBlocks.COMPACTED_STAR_METAL.get().asItem());
			})

					.build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> QUEST_ITEMS = REGISTRY.register("quest_items",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.geafm.quest_items")).icon(() -> new ItemStack(Items.IRON_SWORD)).displayItems((parameters, tabData) -> {
				tabData.accept(GeafmModItems.STAR_EMERALD.get());
				tabData.accept(GeafmModItems.DRAGON_SCALES.get());
				tabData.accept(GeafmModItems.DRAGON_SLAYER_QUEST.get());
				tabData.accept(GeafmModItems.DRAGON_SLAYER_TICKET.get());
				tabData.accept(GeafmModItems.FLIGHT_QUEST.get());
				tabData.accept(GeafmModItems.FLIGHT_QUEST_TICKET.get());
			})

					.build());
}
