
package net.mcreator.geafm.item;

import net.minecraft.world.level.Level;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.item.Rarity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.entity.Entity;
import net.minecraft.network.chat.Component;

import net.mcreator.geafm.procedures.GiveDragonSlayerTicketRecipeProcedure;

import java.util.List;

public class DragonSlayerQuestItem extends Item {
	public DragonSlayerQuestItem() {
		super(new Item.Properties().stacksTo(1).fireResistant().rarity(Rarity.UNCOMMON));
	}

	@Override
	public void appendHoverText(ItemStack itemstack, Level level, List<Component> list, TooltipFlag flag) {
		super.appendHoverText(itemstack, level, list, flag);
		list.add(Component.literal("Slay the ender dragon"));
		list.add(Component.literal("Craft Dragon Slayer Ticket"));
		list.add(Component.literal("\u00A71\u00A7bQuest Item"));
	}

	@Override
	public void inventoryTick(ItemStack itemstack, Level world, Entity entity, int slot, boolean selected) {
		super.inventoryTick(itemstack, world, entity, slot, selected);
		GiveDragonSlayerTicketRecipeProcedure.execute(entity);
	}
}
