package net.mcreator.geafm.procedures;

import net.neoforged.neoforge.items.ItemHandlerHelper;

import net.minecraft.world.phys.Vec3;
import net.minecraft.world.phys.Vec2;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.GameRules;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.effect.MobEffectInstance;
import net.minecraft.util.RandomSource;
import net.minecraft.util.Mth;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.resources.ResourceKey;
import net.minecraft.network.protocol.game.ClientboundUpdateMobEffectPacket;
import net.minecraft.network.protocol.game.ClientboundPlayerAbilitiesPacket;
import net.minecraft.network.protocol.game.ClientboundLevelEventPacket;
import net.minecraft.network.protocol.game.ClientboundGameEventPacket;
import net.minecraft.network.chat.Component;
import net.minecraft.core.registries.Registries;
import net.minecraft.core.BlockPos;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.commands.CommandSource;
import net.minecraft.advancements.AdvancementProgress;
import net.minecraft.advancements.AdvancementHolder;

import net.mcreator.geafm.network.GeafmModVariables;
import net.mcreator.geafm.init.GeafmModItems;
import net.mcreator.geafm.GeafmMod;

public class AscendPlayerProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity) {
		if (entity == null)
			return;
		if (!((entity.level().dimension()) == ResourceKey.create(Registries.DIMENSION, new ResourceLocation("geafm:ascension_dimension")))) {
			{
				GeafmModVariables.PlayerVariables _vars = entity.getData(GeafmModVariables.PLAYER_VARIABLES);
				_vars.IsKeepInventoryOn = world.getLevelData().getGameRules().getBoolean(GameRules.RULE_KEEPINVENTORY);
				_vars.syncPlayerVariables(entity);
			}
			world.getLevelData().getGameRules().getRule(GameRules.RULE_KEEPINVENTORY).set(true, world.getServer());
			world.getLevelData().getGameRules().getRule(GameRules.RULE_FALL_DAMAGE).set(false, world.getServer());
			{
				GeafmModVariables.PlayerVariables _vars = entity.getData(GeafmModVariables.PLAYER_VARIABLES);
				_vars.TimesAscended = entity.getData(GeafmModVariables.PLAYER_VARIABLES).TimesAscended + 1;
				_vars.syncPlayerVariables(entity);
			}
			if (entity instanceof ServerPlayer _player && !_player.level().isClientSide()) {
				ResourceKey<Level> destinationType = ResourceKey.create(Registries.DIMENSION, new ResourceLocation("geafm:ascension_dimension"));
				if (_player.level().dimension() == destinationType)
					return;
				ServerLevel nextLevel = _player.server.getLevel(destinationType);
				if (nextLevel != null) {
					_player.connection.send(new ClientboundGameEventPacket(ClientboundGameEventPacket.WIN_GAME, 0));
					_player.teleportTo(nextLevel, _player.getX(), _player.getY(), _player.getZ(), _player.getYRot(), _player.getXRot());
					_player.connection.send(new ClientboundPlayerAbilitiesPacket(_player.getAbilities()));
					for (MobEffectInstance _effectinstance : _player.getActiveEffects())
						_player.connection.send(new ClientboundUpdateMobEffectPacket(_player.getId(), _effectinstance));
					_player.connection.send(new ClientboundLevelEventPacket(1032, BlockPos.ZERO, 0, false));
				}
			}
			if (entity instanceof Player _player)
				_player.getInventory().clearContent();
			while ((entity instanceof Player _plr ? _plr.experienceLevel : 0) != 0) {
				if (entity instanceof Player _player)
					_player.giveExperienceLevels(-(1));
				if (entity instanceof Player _player) {
					ItemStack _setstack = new ItemStack(GeafmModItems.HEAVENLY_FRAGMENT.get()).copy();
					_setstack.setCount(Mth.nextInt(RandomSource.create(), 1, (int) entity.getData(GeafmModVariables.PLAYER_VARIABLES).TimesAscended));
					ItemHandlerHelper.giveItemToPlayer(_player, _setstack);
				}
			}
			if (entity.getData(GeafmModVariables.PLAYER_VARIABLES).TimesAscended <= 1) {
				if (entity instanceof Player _player) {
					ItemStack _setstack = new ItemStack(GeafmModItems.HEAVENLY_FRAGMENT.get()).copy();
					_setstack.setCount(Mth.nextInt(RandomSource.create(), 3, 7));
					ItemHandlerHelper.giveItemToPlayer(_player, _setstack);
				}
				if (entity instanceof ServerPlayer _player) {
					AdvancementHolder _adv = _player.server.getAdvancements().get(new ResourceLocation("geafm:player_ascends_first_time"));
					if (_adv != null) {
						AdvancementProgress _ap = _player.getAdvancements().getOrStartProgress(_adv);
						if (!_ap.isDone()) {
							for (String criteria : _ap.getRemainingCriteria())
								_player.getAdvancements().award(_adv, criteria);
						}
					}
				}
				if (entity instanceof ServerPlayer _player) {
					AdvancementHolder _adv = _player.server.getAdvancements().get(new ResourceLocation("geafm:player_ascends_the_first_time_2"));
					if (_adv != null) {
						AdvancementProgress _ap = _player.getAdvancements().getOrStartProgress(_adv);
						if (!_ap.isDone()) {
							for (String criteria : _ap.getRemainingCriteria())
								_player.getAdvancements().award(_adv, criteria);
						}
					}
				}
				if (!entity.getData(GeafmModVariables.PLAYER_VARIABLES).FreeAscensionBought) {
					if (entity instanceof Player _player) {
						ItemStack _setstack = new ItemStack(GeafmModItems.ASCENSION_BAG.get()).copy();
						_setstack.setCount(1);
						ItemHandlerHelper.giveItemToPlayer(_player, _setstack);
					}
				}
			} else if (entity.getData(GeafmModVariables.PLAYER_VARIABLES).TimesAscended >= 10) {
				if (entity instanceof Player _player) {
					ItemStack _setstack = new ItemStack(GeafmModItems.HEAVENLY_FRAGMENT.get()).copy();
					_setstack.setCount((int) entity.getData(GeafmModVariables.PLAYER_VARIABLES).TimesAscended);
					ItemHandlerHelper.giveItemToPlayer(_player, _setstack);
				}
				if (!entity.getData(GeafmModVariables.PLAYER_VARIABLES).FreeAscensionBought) {
					if (entity instanceof Player _player) {
						ItemStack _setstack = new ItemStack(GeafmModItems.ASCENSION_BAG_TIER_2.get()).copy();
						_setstack.setCount(1);
						ItemHandlerHelper.giveItemToPlayer(_player, _setstack);
					}
				}
			} else if (entity.getData(GeafmModVariables.PLAYER_VARIABLES).TimesAscended > 1) {
				if (entity instanceof Player _player) {
					ItemStack _setstack = new ItemStack(GeafmModItems.HEAVENLY_FRAGMENT.get()).copy();
					_setstack.setCount(Mth.nextInt(RandomSource.create(), (int) (entity.getData(GeafmModVariables.PLAYER_VARIABLES).TimesAscended - 1), (int) (entity.getData(GeafmModVariables.PLAYER_VARIABLES).TimesAscended * 2)));
					ItemHandlerHelper.giveItemToPlayer(_player, _setstack);
				}
			}
			if (world instanceof ServerLevel _level)
				_level.getServer().getCommands().performPrefixedCommand(new CommandSourceStack(CommandSource.NULL, new Vec3(x, y, z), Vec2.ZERO, _level, 4, "", Component.literal(""), _level.getServer(), null).withSuppressedOutput(),
						"/tellraw @p {\"text\":\"\",\"extra\":[{\"text\":\"Someone has ascended\",\"color\":\"yellow\"}]}");
			GeafmMod.queueServerWork(40, () -> {
				{
					Entity _ent = entity;
					_ent.teleportTo(0, y, 0);
					if (_ent instanceof ServerPlayer _serverPlayer)
						_serverPlayer.connection.teleport(0, y, 0, _ent.getYRot(), _ent.getXRot());
				}
			});
			{
				GeafmModVariables.PlayerVariables _vars = entity.getData(GeafmModVariables.PLAYER_VARIABLES);
				_vars.IsInAscensionDimension = true;
				_vars.syncPlayerVariables(entity);
			}
		} else if ((entity.level().dimension()) == ResourceKey.create(Registries.DIMENSION, new ResourceLocation("geafm:ascension_dimension"))) {
			if (world instanceof ServerLevel _level)
				_level.getServer().getCommands().performPrefixedCommand(new CommandSourceStack(CommandSource.NULL, new Vec3(x, y, z), Vec2.ZERO, _level, 4, "", Component.literal(""), _level.getServer(), null).withSuppressedOutput(),
						"/tellraw @p {\"text\":\"\",\"extra\":[{\"text\":\"Cannot Ascend, already ascended\",\"color\":\"yellow\"}]}");
		}
	}
}
