package net.mcreator.geafm.procedures;

import net.neoforged.neoforge.event.entity.living.LivingDeathEvent;
import net.neoforged.fml.common.Mod;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.bus.api.Event;

import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.monster.WitherSkeleton;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.entity.Entity;
import net.minecraft.util.RandomSource;
import net.minecraft.util.Mth;
import net.minecraft.server.level.ServerLevel;

import net.mcreator.geafm.network.GeafmModVariables;
import net.mcreator.geafm.init.GeafmModItems;

import javax.annotation.Nullable;

@Mod.EventBusSubscriber
public class WitherSkeltonLTProcedure {
	@SubscribeEvent
	public static void onEntityDeath(LivingDeathEvent event) {
		if (event != null && event.getEntity() != null) {
			execute(event, event.getEntity().level(), event.getEntity().getX(), event.getEntity().getY(), event.getEntity().getZ(), event.getEntity());
		}
	}

	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity) {
		execute(null, world, x, y, z, entity);
	}

	private static void execute(@Nullable Event event, LevelAccessor world, double x, double y, double z, Entity entity) {
		if (entity == null)
			return;
		double twentyfivepercentchance = 0;
		if (entity instanceof WitherSkeleton) {
			if (entity.getData(GeafmModVariables.PLAYER_VARIABLES).EnderDragonDefeated) {
				if (entity.getData(GeafmModVariables.PLAYER_VARIABLES).WitherDefeated) {
					twentyfivepercentchance = Mth.nextInt(RandomSource.create(), 1, 4);
					if (twentyfivepercentchance == 1) {
						if (world instanceof ServerLevel _level) {
							ItemEntity entityToSpawn = new ItemEntity(_level, x, y, z, new ItemStack(GeafmModItems.NIGHTMARE_FUEL.get()));
							entityToSpawn.setPickUpDelay(10);
							_level.addFreshEntity(entityToSpawn);
						}
					}
				}
			}
		}
	}
}
