package net.mcreator.geafm.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.geafm.world.inventory.AscensionUpgradeTreeMenu;
import net.mcreator.geafm.procedures.ReturnGodXPAmountProcedure;
import net.mcreator.geafm.procedures.ReturnGodBloodAmountProcedure;
import net.mcreator.geafm.network.AscensionUpgradeTreeButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class AscensionUpgradeTreeScreen extends AbstractContainerScreen<AscensionUpgradeTreeMenu> {
	private final static HashMap<String, Object> guistate = AscensionUpgradeTreeMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	ImageButton imagebutton_back3;
	ImageButton imagebutton_freeascension;

	public AscensionUpgradeTreeScreen(AscensionUpgradeTreeMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 425;
		this.imageHeight = 240;
	}

	@Override
	public boolean isPauseScreen() {
		return true;
	}

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.geafm.ascension_upgrade_tree.label_upgrade_tree"), 181, 14, -103, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.geafm.ascension_upgrade_tree.label_ascension"), 190, 26, -103, false);
		guiGraphics.drawString(this.font,

				ReturnGodBloodAmountProcedure.execute(entity), 14, 215, -103, false);
		guiGraphics.drawString(this.font,

				ReturnGodXPAmountProcedure.execute(entity), 14, 206, -6684775, false);
	}

	@Override
	public void init() {
		super.init();
		imagebutton_back3 = new ImageButton(this.leftPos + 1, this.topPos + 1, 30, 18, new WidgetSprites(new ResourceLocation("geafm:textures/screens/back3.png"), new ResourceLocation("geafm:textures/screens/back3.png")), e -> {
			if (true) {
				PacketDistributor.SERVER.noArg().send(new AscensionUpgradeTreeButtonMessage(0, x, y, z));
				AscensionUpgradeTreeButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_back3", imagebutton_back3);
		this.addRenderableWidget(imagebutton_back3);
		imagebutton_freeascension = new ImageButton(this.leftPos + 203, this.topPos + 44, 16, 16, new WidgetSprites(new ResourceLocation("geafm:textures/screens/freeascension.png"), new ResourceLocation("geafm:textures/screens/freeascension.png")),
				e -> {
					if (true) {
						PacketDistributor.SERVER.noArg().send(new AscensionUpgradeTreeButtonMessage(1, x, y, z));
						AscensionUpgradeTreeButtonMessage.handleButtonAction(entity, 1, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_freeascension", imagebutton_freeascension);
		this.addRenderableWidget(imagebutton_freeascension);
	}
}
