package net.mcreator.geafm.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.geafm.world.inventory.MaterialCompressorBookGUIMenu;
import net.mcreator.geafm.procedures.MaterialCompressorRecipeTitle2Procedure;
import net.mcreator.geafm.procedures.MaterialCompressorRecipeTitle1Procedure;
import net.mcreator.geafm.procedures.MaterialCompressorBookShowPreviousProcedure;
import net.mcreator.geafm.procedures.MaterialCompressorBookShowNextProcedure;
import net.mcreator.geafm.network.MaterialCompressorBookGUIButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class MaterialCompressorBookGUIScreen extends AbstractContainerScreen<MaterialCompressorBookGUIMenu> {
	private final static HashMap<String, Object> guistate = MaterialCompressorBookGUIMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Button button_empty;
	Button button_empty1;

	public MaterialCompressorBookGUIScreen(MaterialCompressorBookGUIMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 115;
		this.imageHeight = 145;
	}

	private static final ResourceLocation texture = new ResourceLocation("geafm:textures/screens/material_compressor_book_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/screenshot_2024-06-18_170750.png"), this.leftPos + 44, this.topPos + 46, 0, 0, 30, 22, 30, 22);

		guiGraphics.blit(new ResourceLocation("geafm:textures/screens/screenshot_2024-06-18_170750.png"), this.leftPos + 45, this.topPos + 113, 0, 0, 30, 22, 30, 22);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font,

				MaterialCompressorRecipeTitle1Procedure.execute(entity), 6, 7, -12829636, false);
		guiGraphics.drawString(this.font,

				MaterialCompressorRecipeTitle2Procedure.execute(entity), 6, 74, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		button_empty = Button.builder(Component.translatable("gui.geafm.material_compressor_book_gui.button_empty"), e -> {
			if (MaterialCompressorBookShowNextProcedure.execute(entity)) {
				PacketDistributor.SERVER.noArg().send(new MaterialCompressorBookGUIButtonMessage(0, x, y, z));
				MaterialCompressorBookGUIButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 118, this.topPos + 12, 30, 20).build(builder -> new Button(builder) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int gx, int gy, float ticks) {
				if (MaterialCompressorBookShowNextProcedure.execute(entity))
					super.renderWidget(guiGraphics, gx, gy, ticks);
			}
		});
		guistate.put("button:button_empty", button_empty);
		this.addRenderableWidget(button_empty);
		button_empty1 = Button.builder(Component.translatable("gui.geafm.material_compressor_book_gui.button_empty1"), e -> {
			if (MaterialCompressorBookShowPreviousProcedure.execute(entity)) {
				PacketDistributor.SERVER.noArg().send(new MaterialCompressorBookGUIButtonMessage(1, x, y, z));
				MaterialCompressorBookGUIButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		}).bounds(this.leftPos + -33, this.topPos + 13, 30, 20).build(builder -> new Button(builder) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int gx, int gy, float ticks) {
				if (MaterialCompressorBookShowPreviousProcedure.execute(entity))
					super.renderWidget(guiGraphics, gx, gy, ticks);
			}
		});
		guistate.put("button:button_empty1", button_empty1);
		this.addRenderableWidget(button_empty1);
	}
}
