
/*
 *	MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.geafm.init;

import org.lwjgl.glfw.GLFW;

import net.neoforged.neoforge.network.PacketDistributor;
import net.neoforged.neoforge.event.TickEvent;
import net.neoforged.neoforge.client.event.RegisterKeyMappingsEvent;
import net.neoforged.fml.common.Mod;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.api.distmarker.Dist;

import net.minecraft.client.Minecraft;
import net.minecraft.client.KeyMapping;

import net.mcreator.geafm.network.ResetAllQuestsAndAdvancementsMessage;
import net.mcreator.geafm.network.OpenUpgradeSystemMessage;
import net.mcreator.geafm.network.GiveAllAdvancementsMessage;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD, value = {Dist.CLIENT})
public class GeafmModKeyMappings {
	public static final KeyMapping RESET_ALL_QUESTS_AND_ADVANCEMENTS = new KeyMapping("key.geafm.reset_all_quests_and_advancements", GLFW.GLFW_KEY_N, "key.categories.misc") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				PacketDistributor.SERVER.noArg().send(new ResetAllQuestsAndAdvancementsMessage(0, 0));
				ResetAllQuestsAndAdvancementsMessage.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping GIVE_ALL_ADVANCEMENTS = new KeyMapping("key.geafm.give_all_advancements", GLFW.GLFW_KEY_M, "key.categories.misc") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				PacketDistributor.SERVER.noArg().send(new GiveAllAdvancementsMessage(0, 0));
				GiveAllAdvancementsMessage.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping OPEN_UPGRADE_SYSTEM = new KeyMapping("key.geafm.open_upgrade_system", GLFW.GLFW_KEY_Z, "key.categories.ui") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				PacketDistributor.SERVER.noArg().send(new OpenUpgradeSystemMessage(0, 0));
				OpenUpgradeSystemMessage.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};

	@SubscribeEvent
	public static void registerKeyMappings(RegisterKeyMappingsEvent event) {
		event.register(RESET_ALL_QUESTS_AND_ADVANCEMENTS);
		event.register(GIVE_ALL_ADVANCEMENTS);
		event.register(OPEN_UPGRADE_SYSTEM);
	}

	@Mod.EventBusSubscriber({Dist.CLIENT})
	public static class KeyEventListener {
		@SubscribeEvent
		public static void onClientTick(TickEvent.ClientTickEvent event) {
			if (Minecraft.getInstance().screen == null) {
				RESET_ALL_QUESTS_AND_ADVANCEMENTS.consumeClick();
				GIVE_ALL_ADVANCEMENTS.consumeClick();
				OPEN_UPGRADE_SYSTEM.consumeClick();
			}
		}
	}
}
