
package net.mcreator.geafm.item;

import net.minecraft.world.level.Level;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.Tier;
import net.minecraft.world.item.ShovelItem;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.entity.Entity;

import net.mcreator.geafm.procedures.HitWithTheStarsGetProcedure;
import net.mcreator.geafm.init.GeafmModItems;

public class StarGemToolShovelItem extends ShovelItem {
	public StarGemToolShovelItem() {
		super(new Tier() {
			public int getUses() {
				return 1681;
			}

			public float getSpeed() {
				return 7.5f;
			}

			public float getAttackDamageBonus() {
				return 0.5f;
			}

			public int getLevel() {
				return 3;
			}

			public int getEnchantmentValue() {
				return 12;
			}

			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(GeafmModItems.STAR_GEM.get()));
			}
		}, 1, -3f, new Item.Properties().fireResistant());
	}

	@Override
	public void inventoryTick(ItemStack itemstack, Level world, Entity entity, int slot, boolean selected) {
		super.inventoryTick(itemstack, world, entity, slot, selected);
		HitWithTheStarsGetProcedure.execute(entity);
	}
}
