
package net.mcreator.geafm.item.inventory;

import net.neoforged.neoforge.items.ItemStackHandler;
import net.neoforged.neoforge.event.entity.item.ItemTossEvent;
import net.neoforged.fml.common.Mod;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.api.distmarker.OnlyIn;
import net.neoforged.api.distmarker.Dist;

import net.minecraft.world.item.ItemStack;
import net.minecraft.client.Minecraft;

import net.mcreator.geafm.init.GeafmModItems;
import net.mcreator.geafm.client.gui.MaterialCompressorBookGUIScreen;

import javax.annotation.Nonnull;

@Mod.EventBusSubscriber(Dist.CLIENT)
public class MaterialCompressorRecipeBookInventoryCapability extends ItemStackHandler {
	@SubscribeEvent
	@OnlyIn(Dist.CLIENT)
	public static void onItemDropped(ItemTossEvent event) {
		if (event.getEntity().getItem().getItem() == GeafmModItems.MATERIAL_COMPRESSOR_RECIPE_BOOK.get()) {
			if (Minecraft.getInstance().screen instanceof MaterialCompressorBookGUIScreen) {
				Minecraft.getInstance().player.closeContainer();
			}
		}
	}

	public MaterialCompressorRecipeBookInventoryCapability() {
		super(6);
	}

	@Override
	public int getSlotLimit(int slot) {
		return 64;
	}

	@Override
	public boolean isItemValid(int slot, @Nonnull ItemStack stack) {
		return stack.getItem() != GeafmModItems.MATERIAL_COMPRESSOR_RECIPE_BOOK.get();
	}

	@Override
	public void setSize(int size) {
	}
}
