package net.mcreator.geafm.procedures;

import net.neoforged.neoforge.event.entity.player.PlayerEvent;
import net.neoforged.fml.common.Mod;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.bus.api.Event;

import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.GameRules;
import net.minecraft.world.entity.Entity;
import net.minecraft.util.RandomSource;
import net.minecraft.util.Mth;

import net.mcreator.geafm.network.GeafmModVariables;

import javax.annotation.Nullable;

import java.util.Random;

@Mod.EventBusSubscriber
public class PlayerDiesInAscensionDimensionProcedure {
	@SubscribeEvent
	public static void onPlayerRespawned(PlayerEvent.PlayerRespawnEvent event) {
		execute(event, event.getEntity().level(), event.getEntity());
	}

	public static void execute(LevelAccessor world, Entity entity) {
		execute(null, world, entity);
	}

	private static void execute(@Nullable Event event, LevelAccessor world, Entity entity) {
		if (entity == null)
			return;
		double GodBloodLoss = 0;
		double Random = 0;
		if (!entity.getData(GeafmModVariables.PLAYER_VARIABLES).IsKeepInventoryOn) {
			world.getLevelData().getGameRules().getRule(GameRules.RULE_KEEPINVENTORY).set(false, world.getServer());
		}
		world.getLevelData().getGameRules().getRule(GameRules.RULE_FALL_DAMAGE).set(true, world.getServer());
		if (!entity.getData(GeafmModVariables.PLAYER_VARIABLES).IsInAscensionDimension) {
			if (entity.getData(GeafmModVariables.PLAYER_VARIABLES).GodBlood >= 10) {
				GodBloodLoss = entity.getData(GeafmModVariables.PLAYER_VARIABLES).GodBlood / 10;
			}
			if (entity.getData(GeafmModVariables.PLAYER_VARIABLES).GodBlood >= 11) {
				Random = Mth.nextInt(RandomSource.create(), 1, 2);
				if (Random == 1) {
					GodBloodLoss = GodBloodLoss - Mth.nextInt(RandomSource.create(), 0, 10);
				} else if (Random == 2) {
					GodBloodLoss = GodBloodLoss + Mth.nextInt(RandomSource.create(), 0, 10);
				}
			}
			{
				GeafmModVariables.PlayerVariables _vars = entity.getData(GeafmModVariables.PLAYER_VARIABLES);
				_vars.GodBlood = entity.getData(GeafmModVariables.PLAYER_VARIABLES).GodBlood - GodBloodLoss;
				_vars.syncPlayerVariables(entity);
			}
		}
		{
			GeafmModVariables.PlayerVariables _vars = entity.getData(GeafmModVariables.PLAYER_VARIABLES);
			_vars.IsInAscensionDimension = false;
			_vars.syncPlayerVariables(entity);
		}
	}
}
