package net.mcreator.geafm.procedures;

import net.neoforged.neoforge.event.entity.player.ItemTooltipEvent;
import net.neoforged.fml.common.Mod;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.bus.api.Event;
import net.neoforged.api.distmarker.OnlyIn;
import net.neoforged.api.distmarker.Dist;

import net.minecraft.world.item.ItemStack;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.Screen;

import net.mcreator.geafm.init.GeafmModItems;

import javax.annotation.Nullable;

import java.util.List;

@Mod.EventBusSubscriber(value = {Dist.CLIENT})
public class ShowAdvancedTooltipsProcedure {
	@OnlyIn(Dist.CLIENT)
	@SubscribeEvent
	public static void onItemTooltip(ItemTooltipEvent event) {
		execute(event, event.getItemStack(), event.getToolTip());
	}

	public static void execute(ItemStack itemstack, List<Component> tooltip) {
		execute(null, itemstack, tooltip);
	}

	private static void execute(@Nullable Event event, ItemStack itemstack, List<Component> tooltip) {
		if (tooltip == null)
			return;
		if (itemstack.getItem() == GeafmModItems.MATERIAL_COMPRESSER_FORCE_UPGRADE.get()) {
			if (Screen.hasShiftDown()) {
				tooltip.add(Component.literal(" \u00A78Allows more items to be compressed"));
			}
		} else if (itemstack.getItem() == GeafmModItems.MATERIAL_COMPRESSOR_RECIPE_BOOK.get() || itemstack.getItem() == GeafmModItems.STAR_CRAFTING_TABLE_RECIPE_BOOK.get()) {
			if (Screen.hasShiftDown()) {
				tooltip.add(Component.literal(" \u00A78Shows what the corrosponding block can be used to make"));
			}
		}
	}
}
